﻿using ERP.Core.Enum;
using ERP.Framework.Enum;
using ERP.Framework.WebApi;
using System.ComponentModel.DataAnnotations.Schema;

namespace ERP.Core.Entity
{
    [Table("sys_menu")]
    public class SysMenu : TreeEntity<SysMenu>
    {
        /// <summary>
        /// 菜单名称
        /// </summary>
        public virtual string MenuName { get; set; } = string.Empty;

        /// <summary>
        /// 菜单路由
        /// </summary>
        public virtual string Path { get; set; } = string.Empty;

        /// <summary>
        /// 组件路径
        /// </summary>
        public virtual string Component { get; set; } = string.Empty;

        /// <summary>
        /// 显示隐藏
        /// </summary>
        public virtual bool Visible { get; set; }

        /// <summary>
        /// 菜单类型
        /// </summary>

        public virtual MenuTypeEnum MenuType { get; set; }

        /// <summary>
        /// 菜单状态
        /// </summary>
        public virtual StatusEnum MenuStatus { get; set; }

        /// <summary>
        /// 菜单图标
        /// </summary>
        public virtual string Icon { get; set; } = string.Empty;

        /// <summary>
        /// 权限标识
        /// </summary>
        public virtual string Permission { get; set; } = string.Empty;
    }
}